;;;Bosse-engineering                                                                                       
;;;Dipl.-Ing. Jrn Bosse                                                                                   
;;;Am Klei 5                                                                                               
;;;38458 Velpke                                                                                            
;;;Tel. 05364 / 989 677                                                                                    
;;;mobil. 0176 / 282 323 51                                                                                
;;;bosse@bosse-engineering.com                                                                             
;;;                                                                                                        
;;;--------------------------------------------------------------------------------------------------------
;;;Funktion c:PatIni	        	           							   
;;;													   
;;;Es werden beim Start von BricsCAD die Schraffurdateien "default.pat" und "iso.pat" im Supportordner	   
;;;durch individuelle Schraffurmuster, die noch nicht enthalten sind, ergnzt. 				   
;;;Die Originaldateien werden bei nderung gesichert.							   
;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;globale Variablen:										   	   
;;;                                                                              Jrn Bosse, 06.02.2020    
;;;--------------------------------------------------------------------------------------------------------
;;;V(1.0a) 11.02.20
;;;- Pfade fr "default.pat" und "iso.pat" ber (getvar "RoamableRootFolder")

(defun c:PatIni (/ File4Default File4iso FileDefault FileIso DefaultPatList IsoPatList 4DefaultPatList
                   4IsoPatList DefaultFlag IsoFlag
                )


  (princ "\nerstellt durch Bosse-engineering - www.bosse-engineering.com\n")
  (princ "\n------------------PatIni(1.0a), 11.02.20-----------------------")
  (princ "\nSchraffurmusterdateien \"default.pat\" u. \"iso.pat\" anpassen.")
  (princ "\n---------------------------------------------------------------")
  
  
  ;;;Datei fr individuelle Schrafffurmuster "default.pat" => Bitte Pfad und Dateinamen anpasssen (MEASUREMENT = 1)
  (setq File4Default "C:\\MeineSchraffurmuster\\Meineacad.pat")
  ;;;Datei fr individuelle Schrafffurmuster "iso.pat" => Bitte Pfad und Dateinamen anpasssen (MEASUREMENT = 0)
  (setq File4iso "C:\\MeineSchraffurmuster\\Meineacadiso.pat")


 
  (setq FileDefault (strcat(getvar "RoamableRootFolder")"Support\\default.pat")
        FileIso (strcat(getvar "RoamableRootFolder")"Support\\iso.pat"))


  (if (and (or (findfile File4Default)
               (alert (strcat "Folgende individuelle Schraffurmusterdatei ist nicht vorhanden:\n\n"
                              File4Default
                      )
               )
           )
           (or (findfile File4iso)
               (alert (strcat "Folgende individuelle Schraffurmusterdatei ist nicht vorhanden:\n\n"
                              File4iso
                      )
               )
           )
           (or (findfile FileDefault)
               (alert "Die Schraffurmusterdatei \"default.pat\" ist nicht vorhanden.")
           )
           (or (findfile FileIso)
               (alert "Die Schraffurmusterdatei \"iso.pat\" ist nicht vorhanden.")
           )
      )
    (progn
      (setq DefaultPatList (JB_PatIni:File2List FileDefault)
            IsoPatList (JB_PatIni:File2List FileIso)
            4DefaultPatList (JB_PatIni:File2List File4Default)
            4IsoPatList (JB_PatIni:File2List File4Default)
            DefaultPatList (JB_PatIni:ListCompare DefaultPatList 4DefaultPatList)
            DefaultFlag (cadr DefaultPatList)
            DefaultPatList (car DefaultPatList)
            IsoPatList (JB_PatIni:ListCompare IsoPatList 4IsoPatList)
            IsoFlag (cadr IsoPatList)
            IsoPatList (car IsoPatList)
	    
      )

      (if DefaultFlag (JB_PatIni:FileWrite DefaultPatList FileDefault))
      (if IsoFlag (JB_PatIni:FileWrite IsoPatList FileIso))

      (if (or DefaultFlag IsoFlag)
        (alert "Es wurden Schraffurmusterdateien angepasst. Damit alle Schraffurmuster zur Verfgung stehen muss BricsCAD neu gestartet werden.")
        (alert "Es wurden keine Schraffurmusterdateien angepasst.")
        )


    )
  )
  (princ)
)
;;;MusterNameList
(defun JB_PatIni:File2List:MusterNameList (MusterNameString / )
  (if (vl-string-search "," MusterNameString)
    (list (substr MusterNameString 1 (vl-string-search "," MusterNameString))
          MusterNameString)
    (list MusterNameString
          MusterNameString))
  )
;;;PAT-Datei in LISTE
(defun JB_PatIni:File2List (PatFile / FileStream line FileList Mustername MusterSubContent LineList)
  (if (setq FileStream (open (findfile PatFile) "r"))
    (progn
      (while (setq line (read-line FileStream))
        (setq FileList (cons line FileList))
      )
      (close FileStream)

      (mapcar '(lambda (line)
                       (setq line (vl-string-left-trim " " line))
                 (if (or (= line "") (= (substr line 1 1) ";"))
                   (progn
                     (if (and Mustername MusterSubContent)
                       (setq LineList (cons (list(list MusterName (reverse MusterSubContent))) LineList)
                             MusterName nil
                             MusterSubContent nil
                       )
                     )
                     (setq LineList (cons (list(list (list "PatIniLine" nil) (list line))) LineList))
                   )
                   (if (= (substr line 1 1) "*")
                     (if (and Mustername MusterSubContent)
                       (setq LineList (cons (list(list MusterName (reverse MusterSubContent))) LineList)
                             MusterName (JB_PatIni:File2List:MusterNameList line)
                             MusterSubContent nil)
                       (setq MusterName (JB_PatIni:File2List:MusterNameList line))
                       )
                     (setq MusterSubContent (cons line MusterSubContent))
                   )
                 )
               )
              (reverse FileList)
      )

      (if (and Mustername MusterSubContent)
        (setq LineList (cons (list(list MusterName (reverse MusterSubContent))) LineList)
              MusterName line
              MusterSubContent nil
        )
      )

      (apply 'append (reverse LineList))
    )
  )
)
    
;;;PAT-Datei schreiben, letzten Stand sichern
(defun JB_PatIni:FileWrite (PatList PatFile / SicPath FileStream)
  (setq SicPath (strcat (car (fnsplitl (findfile PatFile)))
                        "PatIni\\"
                        (cadr (fnsplitl (findfile PatFile)))
                        ".pat"
                )
  )

  (if (or (not (findfile SicPath))
          (or (vl-file-delete SicPath)
              (alert (strcat "Die Sicherung der Schraffurmusterdatei konnte nicht gelscht werden, die Schraffurmusterdatei wurden nicht angepasst:\n\n"
                             SicPath
                     )
              )
          )
      )
    (progn
      (vl-mkdir (car (fnsplitl SicPath)))
      (if (or (vl-file-copy (findfile PatFile) SicPath)
              (alert (strcat "Fehler: Die Sicherung der Schraffurmusterdatei konnte nicht erstellt werden, die Schraffurmusterdatei wurden nicht angepasst:\n\n"
                             (findfile PatFile)
                     )
              )
          )
        (progn
          (setq FileStream (open (findfile PatFile) "w"))

          (mapcar '(lambda (MusterSub)
                     (if (/= (car(car MusterSub)) "PatIniLine")
                       (write-line (cadr(car MusterSub)) FileStream)
                     )
                           (mapcar '(lambda (MusterSubLine)
                                            (write-line MusterSubLine FileStream)
                                    )
                                   (cadr MusterSub)
                           )
                   )
                  PatList
          )

          (close FileStream)
          (alert (strcat "Folgende Schraffurmusterdatei wurde angepasst:\n\n"
                         PatFile
                 )
          )
        )
      )
    )
  )
)
  
	
 ;;;Listen vergleichen
(defun JB_PatIni:ListCompare (PatList 4PatList / Flag PatListCompare)
  (setq PatListCompare (mapcar '(lambda(X)
                                  (list (car(car X))(cadr X)))PatList))

  (mapcar '(lambda (X)

                   (if (and (/= (car(car X)) "PatIniLine")
                            (not (assoc(car(car X)) PatListCompare))
                       )
                     (setq PatList (append PatList (list X))
                           Flag 'T
                     )
                   )


           )
          4PatList
  )

  (list PatList Flag)
)


;;;--------------------------------------------------------------------------------------------------------
;;;Info fr Textfenster nach dem laden des Programms							   
;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

(princ (strcat
          "\n|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|"
          "\n|Schraffurmusterdateien \"default.pat\" u. \"iso.pat\" anpassen.    |"
          "\n|---------------------------------------------------------------|"
          "\n|erstellt durch Bosse-engineering - www.bosse-engineering.com   |"
          "\n|---------------------------------------------------------------|"
          "\n|Befehlszeilenaufruf: PATINI                                    |"
          "\n|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|"
          "\n"
          )
       )
(princ)

	 
	 
		      
	      
		    

